/****************************************************************************/
/*  Test MOD-24LR / nrf24L01                                                */
/****************************************************************************/
/*  LEnsE / Julien VILLEMEJANE       /   Institut d'Optique Graduate School */
/****************************************************************************/
/*  Brochage                                                                */
/*      TO COMPLETE                                                         */
/****************************************************************************/
/*  Test réalisé sur Nucléo-F411RE                                          */
/****************************************************************************/

#include "mbed.h"
#include "MOD24_NRF.h"
#include "nRF24.h"

Serial          debug_pc(USBTX, USBRX);
InterruptIn     bp_int(USER_BUTTON);
char    tab[8] = {0xAA, 0x01, 0x10, 0xF0,0xAA, 0x01, 0x10, 0xF0};

PwmOut dirG1(PB_8);
PwmOut dirG2(PC_9);
DigitalOut en(D3);
PwmOut dirD2(PB_14);
PwmOut dirD1(PB_13);
AnalogIn analog_in(A5);
DigitalOut led(LED1);
AnalogIn analog_in2(A1);


/* Main Function */
int main() {

    double meas;
    double tensionUD;
    double meas_LR;
    double tension_LR;
    double varUD;
    double varLR;

    debug_pc.printf("Test\r\n");
    initNRF24();
    
    while(1) {

        meas = analog_in.read();            // Convertit et lit la tension d'entée analogique (valeur entre 0 et 1)
        tensionUD = meas * 3.3;             // Conversion en tension
        meas_LR = analog_in2.read(); // Convertit et lit la tension d'entée analogique (valeur entre 0 et 1)
        tension_LR = meas_LR * 3.3;

        printf("%lf\t",tension_LR);

if(tensionUD>1.8){
    varUD='a';
}
if(tensionUD>2.4){
    varUD='e';
}
if(tensionUD>3.0){
    varUD='f';
}
if(tensionUD<1.4){
    varUD='g';
}
if(tensionUD<0.6){
    varUD='b';
}
if(tensionUD >= 1.4 && tensionUD <= 1.8){
    varUD='o';
}

if(tension_LR>1.75){
    varLR='c';
}
if(tension_LR<1.55){
    varLR='d';
}
if(tension_LR >= 1.55 && tension_LR <= 1.75){
    varLR='o';
}




        tab[0]=varUD;
        tab[1]=varLR;

        if(bp_int == 1){
            nRF24_mod.setRfFrequency(2400);
            nRF24_mod.write( NRF24L01P_PIPE_P0, tab, 8 );
            debug_pc.printf( "SENDED\r\n");
            wait_us(100000);
        }
    }
}