/****************************************************************************/
/*  Test MOD-24LR / nrf24L01                                                */
/****************************************************************************/
/*  LEnsE / Julien VILLEMEJANE       /   Institut d'Optique Graduate School */
/****************************************************************************/
/*  Brochage                                                                */
/*      TO COMPLETE                                                         */
/****************************************************************************/
/*  Test réalisé sur Nucléo-F411RE                                          */
/****************************************************************************/

#include "mbed.h"
#include "MOD24_NRF.h"
#include "nRF24.h"

PwmOut dirG1(PB_8);
PwmOut dirG2(PC_9);
DigitalOut en(D3);
PwmOut dirD2(PB_14);
PwmOut dirD1(PB_13);
AnalogIn analog_in(A0);
DigitalOut led(LED1);
AnalogIn analog_in2(A1);

Serial          debug_pc(USBTX, USBRX);
InterruptIn     bp_int(USER_BUTTON);

/* Main Function */
int main() {
    debug_pc.printf("Test\r\n");
    initNRF24();

    char meas;
    //double tensionUD;
    char meas_LR;
    //double tension_LR;
    double rcu,rcd;

    dirD1.period_ms(10);
    dirD2.period_ms(10);
    dirG1.period_ms(10);
    dirG2.period_ms(10);
    en = 1;

    while(1) {
            /* Lecture donnée depuis nRF24 */
        if ( nRF24_mod.readable() ) {

            // ...read the data into the receive buffer
            rxDataCnt = nRF24_mod.read( NRF24L01P_PIPE_P0, dataReceived, 8);
           
        meas = dataReceived[0];                  // Convertit et lit la tension d'entée analogique (valeur entre 0 et 1)
       // tensionUD = meas * 3.3;             // Conversion en tension
        meas_LR = dataReceived[1];           // Convertit et lit la tension d'entée analogique (valeur entre 0 et 1)
      //  tension_LR = meas_LR * 3.3;
      
printf ("%c\t",meas);
printf ("%c\t",meas_LR);
            // Display the receive buffer contents via the host serial link
            debug_pc.printf("\tD = ");
            for ( int i = 0; i < rxDataCnt; i++ ) {
                debug_pc.printf(" %x \t", dataReceived[i]);
            }
            debug_pc.printf("\r\n");   
        
        
        if(meas == 'a'){                             // Tension UD>1.8  => avancer
            dirG1.write(0.3);
            dirG2.write(0);
            dirD1.write(0.3+0.0175);
            dirD2.write(0);
            }

            if(meas == 'e'){                             // Tension UD>1.8  => avancer
            dirG1.write(0.6);
            dirG2.write(0);
            dirD1.write(0.6+0.0175);
            dirD2.write(0);          
            }          

             if(meas == 'f'){                             // Tension UD>1.8  => avancer
            dirG1.write(0.9);
            dirG2.write(0);
            dirD1.write(0.9+0.0175);
            dirD2.write(0);
            }  


            if(meas == 'b'){                             // Tension UD<1.4  => reculer
            dirG1.write(0);
            dirG2.write(1-0.5);
            dirD1.write(0);
            dirD2.write(1-0.5);
            }

        if(meas == 'g'){                             // Tension UD<1.4  => reculer
            dirG1.write(0);
            dirG2.write(1-0.8);
            dirD1.write(0);
            dirD2.write(1-0.8);
            }
            
        if(meas == 'o'){                                                                       // Reste, ne rien faire
            dirG1.write(0);
            dirG2.write(0);
            dirD1.write(0);
            dirD2.write(0);}
                                                   
        
        
        if(meas_LR=='c'){                // Tension LR>1.75 Tourner à droite
            dirD1.write(0);
            dirD2.write(0);
            }
        
        
        if(meas_LR=='d'){                   // Tension LR<1.55 Tourner à gauche
            dirG1.write(0);
            dirG2.write(0);        
            }
            
        }
        wait_us(10000);
    }
}

